#include <bits/stdc++.h>
using namespace std;

void Bumerang(int n, int q, int* p, int* w, int* s, int* k, long long* ans){
    #define int long long
    multiset<int> skup;
    for(int i=1;i<=n;i++){
        if(p[i] == 1) skup.insert(-w[i]);
    }
    for(int i=1;i<=q;i++){
        skup.erase(-w[s[i]]);
        skup.insert(-k[i]);
        w[s[i]] = k[i];
        int tri = 3;
        int zbir = 0;
        for(auto u:skup){
            if(tri>0){
                zbir+=(-u);
                tri--;
            }
            else break;
        }
        ans[i] = zbir;
    }
}